# All files / src/custom-nodes/node-calls-controller-nodes NodeCallsControllerFunctionNode.ts

100% Statements 21/21
100% Branches 2/2
100% Functions 1/1
100% Lines 18/18

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    741x
    1x

    1x

    1x

    1x

    1x

    1x

    1x
    1x

    1x

    1x

    1x

    517x

    517x
    517x

    517x
    1x

    516x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../container/ServiceIdentifiers';

    import * as format from 'string-template';

    import { TObfuscationEvent } from '../../types/event-emitters/TObfuscationEvent';

    import { IOptions } from '../../interfaces/options/IOptions';

    import { ObfuscationEvents } from '../../enums/ObfuscationEvents';

    import { initializable } from '../../decorators/Initializable';

    import { SingleNodeCallControllerTemplate } from '../../templates/custom-nodes/SingleNodeCallControllerTemplate';

    import { NO_CUSTOM_NODES_PRESET } from '../../options/presets/NoCustomNodes';

    import { AbstractCustomNode } from '../AbstractCustomNode';
    import { JavaScriptObfuscator } from '../../JavaScriptObfuscator';

    @injectable()
    export class NodeCallsControllerFunctionNode extends AbstractCustomNode {
        /**
         * @type {TObfuscationEvent}
         */
        @initializable()
        private appendEvent: TObfuscationEvent;

        /**
         * @type {string}
         */
        @initializable()
        protected callsControllerFunctionName: string;

        /**
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);
        }

        /**
         * @param appendEvent
         * @param callsControllerFunctionName
         */
        public initialize (appendEvent: TObfuscationEvent, callsControllerFunctionName: string): void {
            this.appendEvent = appendEvent;
            this.callsControllerFunctionName = callsControllerFunctionName;
        }

        /**
         * @returns {string}
         */
        protected getTemplate (): string {
            if (this.appendEvent === ObfuscationEvents.AfterObfuscation) {
                return JavaScriptObfuscator.obfuscate(
                    format(SingleNodeCallControllerTemplate(), {
                        singleNodeCallControllerFunctionName: this.callsControllerFunctionName
                    }),
                    {
                        ...NO_CUSTOM_NODES_PRESET,
                        seed: this.options.seed
                    }
                ).getObfuscatedCode();
            }

            return format(SingleNodeCallControllerTemplate(), {
                singleNodeCallControllerFunctionName: this.callsControllerFunctionName
            });
        }
    }